import textwrap


class SetupTemplate:
    @staticmethod
    def get_setup_py() -> str:
        string = textwrap.dedent(
            """\
        \"\"\"
            This file is generated by CPL CLI
        \"\"\"
        
        import setuptools
        
        setuptools.setup(
            name='$Name',
            version='$Version',
            packages=$Packages,
            url='$URL',
            license='$LicenseName',
            author='$Author',
            author_email='$AuthorMail',
            include_package_data=$IncludePackageData,
            description='$Description',
            python_requires='$PyRequires',
            install_requires=$Dependencies,
            entry_points=$EntryPoints,
            package_data=$PackageData
        )
        """
        )

        return string
